unit GrafLib;{⥪ ।  ࠡ  䮬}

INTERFACE

type
        ArcPtr=^Arc;
        Arc=record                 {᮪  ..}
                Vert:Byte;         {p p設  -p  㣠 ..}
                Weight:Real;       {ﭨ  室饩 p設 ..}
                NextArc:ArcPtr;    {⥫  ᫥ p設,
                                pp    室饩 p設 ..}
        end;

        VertexPtr=^Vertex;
        Vertex=record                {***** Vertex -  *****}
                Vert:Byte;              {!!!!! Vert -  設 !!!!!}
                ListArc:ArcPtr;      { 㣨, 騥  ⮩ p設 ..}
                NextVertex:VertexPtr;{⥫  ᫥ ( p) p設 ..}
                Mark:Boolean;        { 祭 p設 ..}
                X,Y:Integer;         {p (??) p設 ..}
        end;

        GrafType=record   { ,  p樯,  ᠬ p ..}
                ListVertex:VertexPtr; {᮪ p設 ..}
                VertNumber:Byte;      {⢮ p設 ..}
                UserWeight:Boolean;   { ᯮ짮 UserWeight ..}
        end;

        NodePtr=^Node; {  p p砩 ⥩ ..}
        Node=record
                Vert:Byte;        {p p設 ..}
                Weight:Real;      { 㣨   ..}
                NextNode:NodePtr; { p設 ⮣ p ..}
                NextLevel:NodePtr;{騩 p ..}
        end;

function FindVertex(Vert:Byte;Graf:GrafType):VertexPtr;
{}
function NewVertex(Vert:Byte;ListArc:ArcPtr;NextVertex:VertexPtr;X,Y:Word):VertexPtr;
{}
function NewArc(Vert:Byte;Weight:Real;NextArc:ArcPtr):ArcPtr;
{}
procedure MakePathTree(Graf:GrafType;Vert:Byte;var PathTree:NodePtr);
{}
procedure DisposeGraf(var CurVertex:VertexPtr);
{}
procedure DisposePathTree(var PathTree:NodePtr);
{}

IMPLEMENTATION

function MarkAll(Graf:GrafType):Boolean;        {  設 祭?}
var
        Temp:VertexPtr;
begin
        Temp:=Graf.ListVertex;
        repeat
                if Temp^.Mark=False then begin
                        MarkAll:=False;
                        exit;
                end;
                Temp:=Temp^.NextVertex;
        until Temp=nil;
        MarkAll:=True;
end;

procedure UnMarkAll(Graf:GrafType);     { ⪨   設}
var
        Temp:VertexPtr;
begin
        Temp:=Graf.ListVertex;
        While Temp<>nil do begin
                Temp^.Mark:=False;
                Temp:=Temp^.NextVertex;
        end;
end;

function FindVertex;    { 㪠⥫  設   }
var
        Temp:VertexPtr;
begin
        Temp:=Graf.ListVertex;
        while (Temp<>nil) and (Temp^.Vert<>Vert) do Temp:=Temp^.NextVertex;
        FindVertex:=Temp;
end;

function NewVertex;     { 設}
var
        Temp:VertexPtr;
begin
        Temp:=new(VertexPtr);
        Temp^.Vert:=Vert;
        Temp^.ListArc:=ListArc;
        Temp^.NextVertex:=NextVertex;
        Temp^.Mark:=False;
        Temp^.X:=X;
        Temp^.Y:=Y;
        NewVertex:=Temp;
end;

function NewArc;        { 㣠}
var
        Temp:ArcPtr;
begin
        Temp:=new(ArcPtr);
        Temp^.Vert:=Vert;
        Temp^.Weight:=Weight;
        Temp^.NextArc:=NextArc;
        NewArc:=Temp;
end;

procedure MakePathTree; { ॢ 砩 ⥩}
Type
        ShortType=record
                Vert:Byte;
                Arc:ArcPtr;
                Weight,SumWeights:Real;
        end;
var
        CurNode:NodePtr;
        CurVertex:VertexPtr;
        ExtraShort:ShortType;
        Short:ShortType;
        Complete:Boolean;       {   㧥  ॢ?}

        function FindNoMark(Vertex:VertexPtr):VertexPtr;        { 祭}
        var
                Temp:VertexPtr;
        begin
                Temp:=Vertex;
                while (Temp<>nil) and (Temp^.Mark<>False) do Temp:=Temp^.NextVertex;
                FindNoMark:=Temp;
        end;

        function FindMark(Vertex:VertexPtr):VertexPtr;  { 祭}
        var
                Temp:VertexPtr;
        begin
                Temp:=Vertex;
                while (Temp<>nil) and (Temp^.Mark<>True) do Temp:=Temp^.NextVertex;
                FindMark:=Temp;
        end;

        procedure GetShort;     { 砩訩 }
        var
                Arc:ArcPtr;
                SumWeights:Real;
                procedure GetNodeWeight(CurNode:NodePtr);
                        function ArcExist:Boolean;      {  㣠?}
                        begin
                                ArcExist:=False;        {६   : }
                                Arc:=FindVertex(CurNode^.Vert,Graf)^.ListArc;
                                if Arc=nil then Exit;
                                while True do begin
                                        {Cࠢ ...}
                                        if Arc^.Vert=CurVertex^.Vert then begin
                                                {᫨  㣠: Temp<-=->Cur,to TRUE!!!}
                                                ArcExist:=True;
                                                Exit;
                                        end;
                                        if Arc^.NextArc=nil then Exit;
                                        Arc:=Arc^.NextArc;
                                end;
                        end;{ArcExist}
                begin
                        if CurNode<>nil then begin
                                SumWeights:=SumWeights+CurNode^.Weight;
                                if ArcExist then
                                        if SumWeights+Arc^.Weight<Short.SumWeights then begin
                                                Short.Weight:=Arc^.Weight;
                                                Short.SumWeights:=SumWeights+Arc^.Weight;
                                                Short.Arc:=Arc;
                                                Short.Vert:=CurNode^.Vert;
                                        end;
                                GetNodeWeight(CurNode^.NextLevel);
                                SumWeights:=SumWeights-CurNode^.Weight;
                                GetNodeWeight(CurNode^.NextNode);
                        end;
                end;{GetNodeWeight}
        begin
                SumWeights:=0;
                Short.SumWeights:=10000;
                Short.Weight:=0;
                Short.Vert:=0;
                Short.Arc:=nil;
                GetNodeWeight(PathTree);
        end;{GetShort}

        procedure AddToTree(CurNode:NodePtr);   { 㧥  ॢ}
        var
                NewNode,TempNode:NodePtr;
        begin
                if CurNode^.Vert=ExtraShort.Vert then begin
                        NewNode:=New(NodePtr);
                        NewNode^.Vert:=ExtraShort.Arc^.Vert;
                        NewNode^.Weight:=ExtraShort.Weight;
                        NewNode^.NextNode:=nil;
                        NewNode^.NextLevel:=nil;
                        if CurNode^.NextLevel=nil then CurNode^.NextLevel:=NewNode
                        else begin
                                TempNode:=CurNode^.NextLevel;
                                while TempNode^.NextNode<>nil do TempNode:=TempNode^.NextNode;
                                TempNode^.NextNode:=NewNode;
                        end;
                        Complete:=True;
                end
                else begin
                        if CurNode^.NextLevel<>nil then AddToTree(CurNode^.NextLevel);
                        if not Complete then
                                if CurNode^.NextNode<>nil then AddToTree(CurNode^.NextNode);
                end;
        end;{AddToTree}

begin   {MakePathTree}
        CurVertex:=FindVertex(Vert,Graf);{ 設, ன}
        CurVertex^.Mark:=True;           { ந ॢ.}
        PathTree:=New(NodePtr);                         { ⠢   ॢ.}
        PathTree^.Vert:=Vert;
        PathTree^.Weight:=0;
        PathTree^.NextNode:=nil;
        PathTree^.NextLevel:=nil;
        if Graf.ListVertex^.NextVertex=nil then Exit;
        repeat
                CurVertex:=FindNoMark(Graf.ListVertex);{ 1st 祭,}
                GetShort;                        { 砩   .}
                ExtraShort:=Short;
                if CurVertex^.NextVertex<>nil then { 2nd 祭.}
                        CurVertex:=FindNoMark(CurVertex^.NextVertex)
                else CurVertex:=nil;
                while CurVertex<>nil do begin    {᫨  稫,   }
                        GetShort;                     { 砩   .}
                        {᫨  ,   }
                        if Short.SumWeights < ExtraShort.SumWeights then ExtraShort:=Short;
                        if CurVertex^.NextVertex<>nil then { ᫥ 祭.}
                                CurVertex:=FindNoMark(CurVertex^.NextVertex)
                        else CurVertex:=nil;
                end;
                if ExtraShort.Vert=0 then Break;                {<<<---It`s ALL Right !!!}
                FindVertex(ExtraShort.Arc^.Vert,Graf)^.Mark:=True;
                {  設.}
                Complete:=False;
                AddToTree(PathTree);    { ॢ ࠘⮬}
        until MarkAll(Graf);
        UnMarkAll(Graf);
end;{MakePathTree}

procedure DisposeGraf;  {᢮    }
        procedure DisposeArc(CurArc:ArcPtr);
        begin
                if CurArc<>nil then begin
                        DisposeArc(CurArc^.NextArc);
                        Dispose(CurArc);
                end;
        end;
begin
        if CurVertex<>nil then begin
                DisposeGraf(CurVertex^.NextVertex);
                DisposeArc(CurVertex^.ListArc);
                Dispose(CurVertex);
        end;
end;


procedure DisposePathTree;      {᢮    ॢ}
begin
        if PathTree<>nil then begin
                DisposePathTree(PathTree^.NextNode);
                DisposePathTree(PathTree^.NextLevel);
                Dispose(PathTree);
        end;
end;{DisposePathTree}

END.